module TypesWorkshop.Context.Data where

type Name = String

data Type
    = TyInteger
    | TyBoolean
    | TyFunction [Type] Type
    deriving (Show, Eq)

data Term
    = Literal Literal
    | Binary Term Operation Term
    | Variable Name
    | Lambda [Parameter] Term
    -- | Let Name Type Term
    -- | Application Term [Term]

data Literal = LitInteger Int | LitBoolean Bool
data Operation = Plus | Minus | And | Or | Equals
data Parameter = Parameter { paramName :: Name, paramType :: Type }