package com.serranofp.types.generics

import arrow.atomic.AtomicLong

object Freshener {
    private val current = AtomicLong(0)

    fun fresh(name: Name): Type.Variable =
        Type.Variable(name, current.incrementAndGet())

    fun fresh(typeScheme: TypeScheme): Pair<List<Type.Variable>, Type> {
        var current = typeScheme.type
        val variables = mutableListOf<Type.Variable>()
        for (param in typeScheme.typeParameters) {
            val variable = fresh(param)
            current = current.substitute(Type.Parameter(param), variable)
            variables.add(variable)
        }
        return variables.reversed() to current
    }
}