package com.serranofp.types.simple

sealed interface Term

sealed interface Literal : Term {
    data class Integer(val value: Int) : Literal
    data object True : Literal
    data object False : Literal
}

enum class Operation {
    Plus, Minus, And, Or, Equals
}

data class Binary(val left: Term, val operation: Operation, val right: Term) : Term

// option 1: use Kotlin types
fun Term.evaluateToKotlin(): Any = TODO()

// option 2: define values
typealias Value = Literal
fun Term.evaluateToValue(): Value = TODO()
