package com.serranofp.types.context

import arrow.core.right
import me.alllex.parsus.parser.getOrThrow
import kotlin.test.Test
import kotlin.test.assertEquals

class Test {
    @Test fun simpleBooleanConstant() {
        val program = TermParser.parse("true").getOrThrow()
        assertEquals(program.typeCheck(), Type.Boolean.right())
    }

    @Test fun simpleSumType() {
        val program = TermParser.parse("1 + 2").getOrThrow()
        assertEquals(program.typeCheck(), Type.Integer.right())
    }

    @Test fun simpleWrongType() {
        val program = TermParser.parse("1 + true").getOrThrow()
        assert(program.typeCheck().isLeft())
    }

    @Test fun resolutionError() {
        val program = TermParser.parse("x").getOrThrow()
        assert(program.typeCheck().isLeft())
    }

    @Test fun body() {
        val program = TermParser.parse("x + x").getOrThrow()
        assert(program.typeCheck().isLeft())
    }

    @Test fun lambda() {
        val program = TermParser.parse("fun (x : Integer) -> x + x").getOrThrow()
        assertEquals(program.typeCheck(), Type.Function(listOf(Type.Integer), Type.Integer).right())
    }
}