package com.serranofp.types.simple

import arrow.core.right
import me.alllex.parsus.parser.getOrThrow
import kotlin.test.Test
import kotlin.test.assertEquals

class Test {
    @Test fun simpleSum() {
        val program = TermParser.parse("1 + 2").getOrThrow()
        assertEquals(program.evaluateToKotlin(), 3)
        assertEquals(program.evaluateToValue(), Literal.Integer(3))
    }

    @Test fun simpleSumType() {
        val program = TermParser.parse("1 + 2").getOrThrow()
        assertEquals(program.typeCheck(), Type.Integer.right())
    }

    @Test fun simpleWrongType() {
        val program = TermParser.parse("1 + true").getOrThrow()
        assert(program.typeCheck().isLeft())
    }
}